package prob1;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * 1.  This class should compile before turning in your assignment. 
 * 
 * 2.  Any compile error in this code means that the signature (spelling of method, return type, parameters) 
 *     of the method YOU wrote is incorrect. Fix your code.
 *      
 * 3.  If you didn't implement a method, then add a "stub" so that this class compiles and to make the grading
 *     process go more smoothly on my end. Some example stubs for various methods:
 * 
 *       public void mergeEmployee(Employee e){
 *       }
 *
 *	     public Employee getEmployeeWithMostHours (Employee[] emps) {
 *		     return null;	
 *	     }
 *
 *       public double getPay() {
 *		     return Double.MIN_VALUE;
 *	     }
 *
 * 4.  If you need to correct the spelling of a method, be sure and use: Refactor/Rename, which changes all
 *     occurrences in all files. See Lab 2 if needed. 
 */ 
public class HW05CompileTest {
	public static void main(String[] args) {
		testCompileRedMartian();
		testCompileGreenMartian();
		testCompileMartianManager();
		System.out.println("All methods have correct signature");
	}
	
	private static void testCompileRedMartian() {
		RedMartian r1 = new RedMartian(1,1,1);
		RedMartian r2 = new RedMartian(2,2);
		Martian m = new RedMartian(1,1,1);
		int id = r1.getId();
		int ten = r1.getTenacity();
		int vol = r1.getVolume();
		int comp = r1.compareTo(r2);
		r1.setVolume(33);
		int pwr = r1.power();
		String spk = r1.speak();
		boolean isSame = r1.equals(r2);
		String msg = r1.toString();
	}
	
	public static void testCompileGreenMartian() {
		GreenMartian g1 = new GreenMartian(1,1);
		GreenMartian g2 = new GreenMartian(2);
		Teleporter t = new GreenMartian(1,1);
		Martian m = new GreenMartian(1,1);
		int id = g1.getId();
		int vol = g1.getVolume();
		g1.setVolume(33);
		int pwr = g1.power();
		String spk = g1.speak();
		int comp = g1.compareTo(g2);
		boolean isSame = g1.equals(g2);
		String tele = g1.teleport("Orck");
		String msg = g1.toString();
	}

	public static void testCompileMartianManager() {
		GreenMartian g2 = new GreenMartian(4,5);
		MartianManager mm = new MartianManager();
		mm.addMartian(g2);
		RedMartian r1 = new RedMartian(1,1,1); // power=2
		RedMartian r2 = new RedMartian(2,2,2); // power=4
		GreenMartian g1 = new GreenMartian(3); // power=1
		ArrayList<Martian> invaders = new ArrayList<>(Arrays.asList(r1,r2,g1));
		mm.absorbColony(invaders);
		ArrayList<Martian> killed = mm.battle(invaders);
		ArrayList<Martian> captured = mm.captureInvaders(invaders);
		boolean isThere = mm.contains(3);
		Martian m = mm.getMartianAt(0);
		Martian m2 = mm.getMartianClosestTo(0);
		Martian m3 = mm.getMartianClosestTo(g1);
		Martian m4 = mm.getMartianWithId(33);
		int num = mm.getNumMartians();
		int num2 = mm.getNumTeleporters();
		ArrayList<Martian> sorted = mm.getSortedMartians();
		Teleporter t = mm.getTeleporterAt(0);
		String grp = mm.groupSpeak();
		String telep = mm.groupTeleport("lerb");
		mm.obliterateTeleporters();
		Martian m5 = mm.removeMartianAt(2);
		Martian m6 = mm.removeMartianWithId(33);
		String msg = mm.toString();
	}
}
